#pragma once


#include "WSQImageLibraryNativeMethods.h"
//#include <string>


// MS Studio 2008 allows only Release mode for 64-bit applications. Debug mode does not work


// Please read the included file "important_notes_for_NET_developers_on_using_WSQ_image_library.html"
// or the page: 
// http://www.cognaxon.com/index.php?page=wsqlib_NETnotes
// FAQ (Frequently Asked Questions)
// for .NET developers on using WSQ image library



namespace wsqdemo {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;


	using namespace System::Runtime::InteropServices; // needed for DllImport
	using namespace System::Text; // needed for StringBuilder Class
	using namespace System::IO;





	/// <summary>
	/// Summary for MainForm
	/// </summary>
	public ref class MainForm : public System::Windows::Forms::Form
	{
	public:
		MainForm(void)
		{

			comment_text = String::Empty; //need to initialize comment_text in order to avoid crashing


			InitializeComponent();
			//
			//TODO: Add the constructor code here
			//
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~MainForm()
		{
			if (components)
			{
				delete components;
			}
		}


	private: wsq_demo::WSQImageLibraryNativeMethods^ WSQ_library_native_methods;

	private:
		IntPtr bp;
		//static IntPtr bp = IntPtr::Zero;
		System::Drawing::Bitmap^ b;
		array<System::Byte>^ input_data_stream;
		array<System::Byte>^ input_data_stream2;
		array<System::Byte>^ output_data_stream;
		array<System::Byte>^ output_data_stream2;
		Int64 pwidth;
		Int64 pheight;
		Int64 ppi;
		double bitrate;
		System::String^ comment_text;
	private: System::Windows::Forms::PictureBox^ OutputPicture;




	private: System::Windows::Forms::Button^ buttonOpen;
	private: System::Windows::Forms::Button^ buttonSave;
	private: System::Windows::Forms::Button^ buttonWsqToStream;
	private: System::Windows::Forms::Button^ buttonStreamToWsq;




	private: System::Windows::Forms::Button^ buttonRegister;

	protected:

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container^ components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->OutputPicture = (gcnew System::Windows::Forms::PictureBox());
			this->buttonOpen = (gcnew System::Windows::Forms::Button());
			this->buttonSave = (gcnew System::Windows::Forms::Button());
			this->buttonWsqToStream = (gcnew System::Windows::Forms::Button());
			this->buttonStreamToWsq = (gcnew System::Windows::Forms::Button());
			this->buttonRegister = (gcnew System::Windows::Forms::Button());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->OutputPicture))->BeginInit();
			this->SuspendLayout();
			// 
			// OutputPicture
			// 
			this->OutputPicture->Location = System::Drawing::Point(0, 0);
			this->OutputPicture->Name = L"OutputPicture";
			this->OutputPicture->Size = System::Drawing::Size(399, 271);
			this->OutputPicture->TabIndex = 0;
			this->OutputPicture->TabStop = false;
			// 
			// buttonOpen
			// 
			this->buttonOpen->Location = System::Drawing::Point(9, 331);
			this->buttonOpen->Name = L"buttonOpen";
			this->buttonOpen->Size = System::Drawing::Size(105, 32);
			this->buttonOpen->TabIndex = 1;
			this->buttonOpen->Text = L"Open";
			this->buttonOpen->UseVisualStyleBackColor = true;
			this->buttonOpen->Click += gcnew System::EventHandler(this, &MainForm::buttonOpen_Click);
			// 
			// buttonSave
			// 
			this->buttonSave->Enabled = false;
			this->buttonSave->Location = System::Drawing::Point(139, 331);
			this->buttonSave->Name = L"buttonSave";
			this->buttonSave->Size = System::Drawing::Size(105, 32);
			this->buttonSave->TabIndex = 2;
			this->buttonSave->Text = L"Save";
			this->buttonSave->UseVisualStyleBackColor = true;
			this->buttonSave->Click += gcnew System::EventHandler(this, &MainForm::buttonSave_Click);
			// 
			// buttonWsqToStream
			// 
			this->buttonWsqToStream->Location = System::Drawing::Point(9, 277);
			this->buttonWsqToStream->Name = L"buttonWsqToStream";
			this->buttonWsqToStream->Size = System::Drawing::Size(105, 32);
			this->buttonWsqToStream->TabIndex = 3;
			this->buttonWsqToStream->Text = L"WSQ -> Stream";
			this->buttonWsqToStream->UseVisualStyleBackColor = true;
			this->buttonWsqToStream->Click += gcnew System::EventHandler(this, &MainForm::buttonWsqToStream_Click);
			// 
			// buttonStreamToWsq
			// 
			this->buttonStreamToWsq->Enabled = false;
			this->buttonStreamToWsq->Location = System::Drawing::Point(139, 277);
			this->buttonStreamToWsq->Name = L"buttonStreamToWsq";
			this->buttonStreamToWsq->Size = System::Drawing::Size(105, 32);
			this->buttonStreamToWsq->TabIndex = 4;
			this->buttonStreamToWsq->Text = L"Stream -> WSQ";
			this->buttonStreamToWsq->UseVisualStyleBackColor = true;
			this->buttonStreamToWsq->Click += gcnew System::EventHandler(this, &MainForm::buttonStreamToWsq_Click);
			// 
			// buttonRegister
			// 
			this->buttonRegister->Location = System::Drawing::Point(259, 277);
			this->buttonRegister->Name = L"buttonRegister";
			this->buttonRegister->Size = System::Drawing::Size(105, 32);
			this->buttonRegister->TabIndex = 5;
			this->buttonRegister->Text = L"Register";
			this->buttonRegister->UseVisualStyleBackColor = true;
			this->buttonRegister->Click += gcnew System::EventHandler(this, &MainForm::buttonRegister_Click);
			// 
			// MainForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(374, 383);
			this->Controls->Add(this->buttonRegister);
			this->Controls->Add(this->buttonStreamToWsq);
			this->Controls->Add(this->buttonWsqToStream);
			this->Controls->Add(this->buttonSave);
			this->Controls->Add(this->buttonOpen);
			this->Controls->Add(this->OutputPicture);
			this->Name = L"MainForm";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"WSQ Library Demo";
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->OutputPicture))->EndInit();
			this->ResumeLayout(false);

		}
#pragma endregion


		//std::string/std::wstring

		[DllImport("WSQ_library64.dll", EntryPoint = "CreateBMPFromFile", CharSet = CharSet::Unicode)]
		static IntPtr CreateBMPFromFile(array<System::Byte>^ filename);

		[DllImport("WSQ_library64.dll", EntryPoint = "SaveBMPToFile", CharSet = CharSet::Unicode)]
		static void SaveBMPToFile(IntPtr hBitmap, array<System::Byte>^ filename, Int64 filetype);

		[DllImport("WSQ_library64.dll", EntryPoint = "RegisterWSQ", CharSet = CharSet::Unicode)]
		static void RegisterWSQ();

		[DllImport("WSQ_library64.dll", EntryPoint = "SetShowFilePropertiesDialog", CharSet = CharSet::Unicode)]
		static void SetShowFilePropertiesDialog(Int64 file_properties_dialog);

		[DllImport("WSQ_library64.dll", EntryPoint = "ShowFileConverter", CharSet = CharSet::Unicode)]
		static void ShowFileConverter();

		[DllImport("WSQ_library64.dll", EntryPoint = "ConvertHBITMAPtoGrayScale256", CharSet = CharSet::Unicode)]
		static IntPtr ConvertHBITMAPtoGrayScale256(IntPtr hBitmap);

		[DllImport("WSQ_library64.dll", EntryPoint = "SaveHBITMAPtoFileAsGrayScale256BMP", CharSet = CharSet::Unicode)]
		static void SaveHBITMAPtoFileAsGrayScale256BMP(IntPtr hBitmap, array<System::Byte>^ filename);




	private: System::Void buttonOpen_Click(System::Object^ sender, System::EventArgs^ e) {


		OpenFileDialog^ ofd = gcnew OpenFileDialog();

		ofd->Filter = "All images|*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jpeg;*.jp2;*.jpc;\
*.png;*.gif;*.tga;*.pcx;*.ppm;*.pgm;*.pbm;*.ico;*.wmf;*.wbmp;*.ska;*.mng;*.pnm;*.ras;*.raw;|\
FBI's Wavelet Scalar Quantization (*.wsq)|*.wsq|\
Windows Bitmap Graphics (*.bmp)|*.bmp|\
Macintosh Tagged Information File Format images (*.tiff)|*.tiff|\
PC Tagged Information File Format images (*.tif)|*.tif|\
Joint Photographic Experts Group images (*.jpg)|*.jpg|\
Joint Photographic Experts Group images (*.jpeg)|*.jpeg|\
JPEG2000 Part 1 images (*.jp2)|*.jp2|\
JPEG2000 Code Stream images (*.jpc)|*.jpc|\
Portable Network Graphics images (*.png)|*.png|\
Compuserve Graphic Interchange Format images (*.gif)|*.gif|\
Truevision Targa Graphic images (*.tga )|*.tga|\
ZSoft Paintbrush images (PC Paintbrush Bitmap Graphic) (*.pcx)|*.pcx|\
Portable Pixel Map Images (*.ppm)|*.ppm|\
Portable Gray Map Images (*.pgm)|*.pgm|\
Portable Bitmap Images (*.pbm)|*.pbm|\
Windows Icons (*.ico)|*.ico|\
Windows Metafiles (*.wmf)|*.wmf|\
Wireless Bitmap File Format (*.wbmp)|*.wbmp|\
SKA Format images (*.ska)|*.ska|\
Muti-image Network Graphic Animation (*.mng)|*.mng|\
PBM Portable Any Map Graphic Bitmap (*.pnm)|*.pnm|\
Sun Graphic (*.ras)|*.ras|\
RAW Graphic (*.raw)|*.raw";

		ofd->FilterIndex = 1;
		if (ofd->ShowDialog() != System::Windows::Forms::DialogResult::OK)
		{
			return;
		}

		//you can use commented line of code bellow or you can use method from class WSQ_library_native_methods

		UTF8Encoding^ utf8 = gcnew UTF8Encoding;
		bp = CreateBMPFromFile(utf8->GetBytes(ofd->FileName));
		
		//bp = WSQ_library_native_methods->pCreateBMPFromFile(ofd->FileName);

		b = Image::FromHbitmap(bp);
		OutputPicture->Image = b;

		Int32 h = OutputPicture->Image->Height;
		Int32 w = OutputPicture->Image->Width;
		OutputPicture->SetBounds(0, 0, w, h);

		buttonSave->Enabled = true;

	}

	private: System::Void buttonSave_Click(System::Object^ sender, System::EventArgs^ e) {

		SaveFileDialog^ sfd = gcnew SaveFileDialog();
		sfd->Filter = "WSQ Files (*.wsq)|*.wsq|\
Windows BMP (*.bmp)|*.bmp|\
TIFF Files (*.tif)|*.tif|\
PNG Files (*.png)|*.png|\
JPEG Files (*.jpg)|*.jpg|\
Targa Files (*.tga)|*.tga|\
SGI Files (*.rgb)|*.rgb|\
JPEG-2000 Part-1 (*.jp2)|*.jp2|\
JPEG-2000 Code Stream (*.jpc)|*.jpc|\
PBM - Portable Bitmap Format (*.pbm)|*.pbm|\
PGM - Portable Graymap Format (*.pgm)|*.pgm|\
PPM - Portable Pixmap Format (*.ppm)|*.ppm|\
GIF Files (*.gif)|*.gif|\
PNM Files (*.pnm)|*.pnm|\
RAS Files (*.ras)|*.ras|\
MNG Files (*.mng)|*.mng|\
PCX Files (*.pcx)|*.pcx";

		sfd->FilterIndex = 1;
		if (sfd->ShowDialog() != System::Windows::Forms::DialogResult::OK)
		{
			return;
		}

		//you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
		//_SetShowFilePropertiesDialog(1);
		WSQ_library_native_methods->pSetShowFilePropertiesDialog(1);

		Bitmap^ b;
		IntPtr bp;

		b = gcnew Bitmap(OutputPicture->Image);
		bp = b->GetHbitmap();

		//you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
		UTF8Encoding^ utf8 = gcnew UTF8Encoding;
		SaveBMPToFile(bp, utf8->GetBytes(sfd->FileName), sfd->FilterIndex);

		//WSQ_library_native_methods->pSaveBMPToFile(bp, sfd->FileName, sfd->FilterIndex);

	}

	private: System::Void buttonRegister_Click(System::Object^ sender, System::EventArgs^ e) {


// "RegisterWSQ64.exe" and "WSQ image library (for Windows 64-bit)" were compiled using Microsoft Visual C++ 2008 version compiler.
// If it fails to run then you need to install “Microsoft Visual C++ 2008 Redistributable Package (x64)”.
// The download link is:
// https://www.microsoft.com/en-us/download/details.aspx?id=26368
// Microsoft Visual C++ 2008 Redistributable Package (x64)			 
			 
			//you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
			//RegisterWSQ();
			WSQ_library_native_methods->pRegisterWSQ();

	}



	private: System::Void buttonWsqToStream_Click(System::Object^ sender, System::EventArgs^ e) {


		OpenFileDialog^ ofd = gcnew OpenFileDialog();

		ofd->Filter = "FBI Wavelet Scalar Quantization (*.wsq)|*.wsq";

		ofd->FilterIndex = 1;
		if (ofd->ShowDialog() != System::Windows::Forms::DialogResult::OK)
		{
			return;
		}

		FileInfo^ fInfo = gcnew FileInfo(ofd->FileName);
		System::Int64 input_stream_length = fInfo->Length;
		FileStream^ fStream = gcnew FileStream(ofd->FileName, FileMode::Open, FileAccess::Read);
		BinaryReader^ br = gcnew BinaryReader(fStream);

		input_data_stream = br->ReadBytes(safe_cast<int>(input_stream_length));

		WSQ_library_native_methods->pWSQ_decode_stream(input_data_stream, safe_cast<int>(input_stream_length), output_data_stream, pwidth, pheight, ppi, comment_text);

		//Converts WSQ compressed byte array into HBITMAP for showing on screen
		bp = WSQ_library_native_methods->pCreateBMPFromWSQByteArray(input_data_stream, safe_cast<int>(input_stream_length));
		b = Image::FromHbitmap(bp);
		OutputPicture->Image = b;

		Int32 h = OutputPicture->Image->Height;
		Int32 w = OutputPicture->Image->Width;
		OutputPicture->SetBounds(0, 0, w, h);

		Int64 output_data_stream_length = pheight * pwidth;

		// Saves WSQ compressed byte array to an image file.
	//	WSQ_library_native_methods->pSaveWSQByteArrayToImageFile(input_data_stream, (int)input_stream_length, "C:\\OutputDirectory\\output.jpg", 5);


		MessageBox::Show("WSQ file was loaded into memory stream and decompressed into another memory stream.\nNow please press button \"stream -> WSQ\" to compress memory stream and save it to file.\nWSQ compressed byte array was converted to HBITMAP for showing on screen.");

		br->Close();
		fStream->Close();

		buttonStreamToWsq->Enabled = true;

	}
private: System::Void buttonStreamToWsq_Click(System::Object^ sender, System::EventArgs^ e) {


	SaveFileDialog^ sfd = gcnew SaveFileDialog();
	sfd->Filter = "WSQ Files (*.wsq)|*.wsq";
	sfd->FilterIndex = 1;
	if (sfd->ShowDialog() != System::Windows::Forms::DialogResult::OK)
	{
		return;
	}


	bitrate = 0.75;
	ppi = 500;
	//comment_text = "";
	comment_text = "Cognaxon";


	input_data_stream2 = gcnew array<System::Byte>((int)(pwidth * pheight));
	Int64 row, row2, pixel_number, pixel_number2;

	// MAKE A MIRRORED/FLIPPED IMAGE (UP<->DOWN and LEFT<->RIGHT)
	for (Int64 y = 0; y < pheight; y++)
	{
		row = pwidth * y;
		row2 = pwidth * (pheight - y - 1);
		for (Int64 x = 0; x < pwidth; x++)
		{
			pixel_number = row + x;
			pixel_number2 = row2 + (pwidth - x - 1);

			input_data_stream2[pixel_number2] = output_data_stream[pixel_number];
		}
	}

	Int64 compressedLength;
	WSQ_library_native_methods->pWSQ_encode_stream(input_data_stream2,
		pwidth, pheight, bitrate, ppi, comment_text,
		output_data_stream2, compressedLength);


	FileStream^ fStream = gcnew FileStream(sfd->FileName, FileMode::OpenOrCreate);
	BinaryWriter^ bw = gcnew BinaryWriter(fStream);

	bw->Write(output_data_stream2);
	bw->Close();
	fStream->Close();
	MessageBox::Show("Memory stream was compressed into another memory stream and saved to WSQ file.\nNow please press button \"Open\", select the saved file, open it and have a look at the\nresults of memory stream processing. The processed image is mirrored/flipped\n(UP<->DOWN and LEFT<->RIGHT).");

}
};

};



